/* $Id$
 * ===========================================================================
 *
 *                            PUBLIC DOMAIN NOTICE
 *               National Center for Biotechnology Information
 *
 *  This software/database is a "United States Government Work" under the
 *  terms of the United States Copyright Act.  It was written as part of
 *  the author's official duties as a United States Government employee and
 *  thus cannot be copyrighted.  This software/database is freely available
 *  to the public for use. The National Library of Medicine and the U.S.
 *  Government have not placed any restriction on its use or reproduction.
 *
 *  Although all reasonable efforts have been taken to ensure the accuracy
 *  and reliability of the software and data, the NLM and the U.S.
 *  Government do not and cannot warrant the performance or results that
 *  may be obtained by using this software or data. The NLM and the U.S.
 *  Government disclaim all warranties, express or implied, including
 *  warranties of performance, merchantability or fitness for any particular
 *  purpose.
 *
 *  Please cite the author in any work or product based on this material.
 *
 * ===========================================================================
 *
 * File Description:
 *   This code was generated by application DATATOOL
 *   using the following specifications:
 *   'pubmed.asn'.
 *
 * ATTENTION:
 *   Don't edit or commit this file into CVS as this file will
 *   be overridden (by DATATOOL) without warning!
 * ===========================================================================
 */

// standard includes
#include <ncbi_pch.hpp>
#include <serial/serialimpl.hpp>

// generated includes
#include <objects/pubmed/Pubmed_entry.hpp>
#include <objects/medline/Medline_entry.hpp>
#include <objects/pubmed/Pubmed_url.hpp>
BEGIN_NCBI_SCOPE

BEGIN_objects_SCOPE // namespace ncbi::objects::


// generated classes

void CPubmed_entry_Base::ResetMedent(void)
{
    m_Medent.Reset();
}

void CPubmed_entry_Base::SetMedent(CPubmed_entry_Base::TMedent& value)
{
    m_Medent.Reset(&value);
}

CPubmed_entry_Base::TMedent& CPubmed_entry_Base::SetMedent(void)
{
    if ( !m_Medent )
        m_Medent.Reset(new ncbi::objects::CMedline_entry());
    return (*m_Medent);
}

void CPubmed_entry_Base::ResetPublisher(void)
{
    m_Publisher.erase();
    m_set_State[0] &= ~0x30;
}

void CPubmed_entry_Base::ResetUrls(void)
{
    m_Urls.clear();
    m_set_State[0] &= ~0xc0;
}

void CPubmed_entry_Base::ResetPubid(void)
{
    m_Pubid.erase();
    m_set_State[0] &= ~0x300;
}

void CPubmed_entry_Base::Reset(void)
{
    ResetPmid();
    ResetMedent();
    ResetPublisher();
    ResetUrls();
    ResetPubid();
}

BEGIN_NAMED_BASE_CLASS_INFO("Pubmed-entry", CPubmed_entry)
{
    SET_CLASS_MODULE("NCBI-PubMed");
    ADD_NAMED_MEMBER("pmid", m_Pmid, CLASS, (CPubMedId))->SetSetFlag(MEMBER_PTR(m_set_State[0]));
    ADD_NAMED_REF_MEMBER("medent", m_Medent, CMedline_entry)->SetOptional();
    ADD_NAMED_STD_MEMBER("publisher", m_Publisher)->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    ADD_NAMED_MEMBER("urls", m_Urls, STL_list_set, (STL_CRef, (CLASS, (CPubmed_url))))->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    ADD_NAMED_STD_MEMBER("pubid", m_Pubid)->SetSetFlag(MEMBER_PTR(m_set_State[0]))->SetOptional();
    info->RandomOrder();
}
END_CLASS_INFO

// constructor
CPubmed_entry_Base::CPubmed_entry_Base(void)
    : m_Pmid(CPubMedId(0))
{
    memset(m_set_State,0,sizeof(m_set_State));
}

// destructor
CPubmed_entry_Base::~CPubmed_entry_Base(void)
{
}



END_objects_SCOPE // namespace ncbi::objects::

END_NCBI_SCOPE

